%% CDO Valuation using single factor Merton's Model of default
% By Redouane Elkamhi, 2009
clc; clear;

%% Simulation and tranche parameters
SimulationNumber = 10000;
FirmNumber = 125;
rho = 0.10;
Maturity = 5;
Tranche30_100 = 87.5;
Tranche15_30  = 18.75;
Tranche10_15  = 6.25;
Tranche7_10   = 3.75;
Tranche3_7    = 5;
Tranche0_3    = 3.75;

%% Calculate the tranche spreads
S = fTrancheSpread(FirmNumber, SimulationNumber, rho, Maturity, Tranche30_100, Tranche15_30, Tranche10_15,...
                   Tranche7_10, Tranche3_7, Tranche0_3);
Spreads = S.*100;

%% Output the results;
Res = dataset({Spreads(1), 'Tranche0_3'},...
              {Spreads(2), 'Tranche3_7'},...
              {Spreads(3), 'Tranche7_10'},...
              {Spreads(4), 'Tranche10_15'},...
              {Spreads(5), 'Tranche15_30'},...
              {Spreads(6), 'Tranche30_100'})
        
         